package com.ekexiu.portal.service;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.StringUtil;
import org.jfw.util.exception.JfwBaseException;

import com.ekexiu.portal.dao.AuthApplyDao;
import com.ekexiu.portal.dao.ProfessorDao;
import com.ekexiu.portal.po.AuthApply;
import com.ekexiu.portal.pojo.AuthApplyInfo;

@Path("/authApply")
public class AuthApplyService {
	@Autowrie
	private AuthApplyDao authApplyDao;
	@Autowrie
	private AuthImageService authImageService;
	@Autowrie
	private ProfessorDao professorDao;

	public AuthApplyDao getAuthApplyDao() {
		return authApplyDao;
	}

	public void setAuthApplyDao(AuthApplyDao authApplyDao) {
		this.authApplyDao = authApplyDao;
	}
	
	public AuthImageService getAuthImageService() {
		return authImageService;
	}

	public void setAuthImageService(AuthImageService authImageService) {
		this.authImageService = authImageService;
	}

	public ProfessorDao getProfessorDao() {
		return professorDao;
	}

	public void setProfessorDao(ProfessorDao professorDao) {
		this.professorDao = professorDao;
	}

	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con, AuthApply authApply) throws SQLException, IOException{
		String authApplyId = StringUtil.buildUUID();
		authApply.setSolveStatus(0);
		authApply.setAuthApplyId(authApplyId);
		this.authApplyDao.insert(con, authApply);
		return authApplyId;
	}
	
	@Post
	@Path("/state")
	public void updateState(@JdbcConn(true) Connection con,String id,Integer state,@Nullable Integer auth,@Nullable String professorId)throws SQLException, JfwBaseException{
		if(state==2){
			if(auth==null) throw new JfwBaseException(10);
			if(professorId==null) throw new JfwBaseException(10);
			if(auth>4 || auth <1) throw new JfwBaseException(11);
			this.professorDao.updateAuthentication(con, professorId, auth);
		}
		this.authApplyDao.updateSolveStatus(con,state,id);
	}
	
	@Get
	@Path("/info")
	public List<AuthApplyInfo> query(@JdbcConn Connection con) throws SQLException{
		return this.authApplyDao.queryInfo(con);
	}
	@Get
	@Path("/info/{id}")
	public AuthApplyInfo query(@JdbcConn Connection con,@PathVar String id) throws SQLException{
		return this.authApplyDao.queryInfo(con, id);
	}
}
